var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", 'react', '../../FocusZone', './Nav.scss'], function (require, exports, React, FocusZone_1) {
    "use strict";
    var Nav = (function (_super) {
        __extends(Nav, _super);
        function Nav() {
            _super.call(this);
            this.state = {
                isGroupExpanded: []
            };
        }
        Nav.prototype.render = function () {
            var _this = this;
            if (!this.props.groups) {
                return null;
            }
            var groupElements = this.props.groups.map(function (group, groupIndex) { return _this._renderGroup(group, groupIndex); });
            return (React.createElement(FocusZone_1.FocusZone, {direction: FocusZone_1.FocusZoneDirection.vertical}, React.createElement("nav", {role: 'navigation', className: 'ms-Nav' + (this.props.isOnTop ? ' is-onTop ms-u-slideRightIn40' : '')}, groupElements)));
        };
        Nav.prototype._renderAnchorLink = function (link) {
            return (React.createElement("a", {className: 'ms-Nav-link' + (_isLinkSelected(link) ? ' is-selected' : ''), href: link.url || 'javascript:', onClick: this.props.onLinkClick, title: link.name}, this.props.onRenderLink(link)));
        };
        Nav.prototype._renderCompositeLink = function (link, linkIndex) {
            return (React.createElement("div", {key: linkIndex, className: 'ms-Nav-links' + (link.isExpanded ? ' is-expanded' : ' is-collapsed')}, React.createElement("button", {className: 'ms-Nav-chevronButton ms-Nav-chevronButton--link', onClick: this._onLinkExpandClicked.bind(this, link), title: (link.isExpanded ? this.props.expandedStateText : this.props.collapsedStateText)}, React.createElement("i", {className: 'ms-Nav-chevron ms-Icon ms-Icon--chevronDown'})), this._renderAnchorLink(link)));
        };
        Nav.prototype._renderLink = function (link, linkIndex, level) {
            return (React.createElement("li", {key: linkIndex}, (level === 0 && link.links && link.links.length > 0 ?
                this._renderCompositeLink(link, linkIndex) : this._renderAnchorLink(link)), (link.isExpanded ? this._renderLinks(link.links, ++level) : null)));
        };
        Nav.prototype._renderLinks = function (links, level) {
            var _this = this;
            if (!links || !links.length) {
                return null;
            }
            var linkElements = links.map(function (link, linkIndex) { return _this._renderLink(link, linkIndex, level); });
            return (React.createElement("ul", null, linkElements));
        };
        Nav.prototype._renderGroup = function (group, groupIndex) {
            var isGroupExpanded = this.state.isGroupExpanded[groupIndex] !== false;
            return (React.createElement("div", {key: groupIndex, className: 'ms-Nav-group' + (isGroupExpanded ? ' is-expanded' : ' is-collapsed')}, (group.name ?
                React.createElement("button", {className: 'ms-Nav-chevronButton ms-Nav-chevronButton--group', onClick: this._onGroupHeaderClicked.bind(this, groupIndex)}, React.createElement("i", {className: 'ms-Nav-chevron ms-Icon ms-Icon--chevronDown'}), group.name) : null), React.createElement("div", {className: 'ms-Nav-groupContent ms-u-slideDownIn20'}, this._renderLinks(group.links, 0))));
        };
        Nav.prototype._onGroupHeaderClicked = function (groupIndex, ev) {
            var currentState = this.state.isGroupExpanded[groupIndex] !== false;
            this.state.isGroupExpanded[groupIndex] = !currentState;
            this.forceUpdate();
            ev.preventDefault();
            ev.stopPropagation();
        };
        Nav.prototype._onLinkExpandClicked = function (link, ev) {
            link.isExpanded = !link.isExpanded;
            this.forceUpdate();
            ev.preventDefault();
            ev.stopPropagation();
        };
        Nav.defaultProps = {
            groups: null,
            onRenderLink: function (link) { return (React.createElement("span", {className: 'ms-Nav-linkText'}, link.name)); }
        };
        return Nav;
    }(React.Component));
    exports.Nav = Nav;
    // A tag used for resolving links.
    var _urlResolver = document.createElement('a');
    function _isLinkSelected(link) {
        if (!link.url) {
            return false;
        }
        _urlResolver.href = link.url || '';
        var target = _urlResolver.href;
        if (location.protocol + '//' + location.host + location.pathname === target) {
            return true;
        }
        if (location.href === target) {
            return true;
        }
        if (location.hash) {
            // Match the hash to the url.
            if (location.hash === link.url) {
                return true;
            }
            // Match a rebased url. (e.g. #foo becomes http://hostname/foo)
            _urlResolver.href = location.hash.substring(1);
            return _urlResolver.href === target;
        }
        return false;
    }
});
